searchData={"items":[{"type":"module","title":"DataDaemon","doc":"DataDog StatsD reporter.","ref":"DataDaemon.html"},{"type":"module","title":"Quick Setup - DataDaemon","doc":"```elixir\n# In your config/config.exs file\nconfig :my_app, Sample.DataDog,\n  url: \"statsd+udp://localhost:8125\"\n\n# In your application code\ndefmodule Sample.DataDog do\n  @moduledoc ~S\"My DataDog reporter.\"\n  use DataDaemon,\n    otp_app: :my_app,\n    extensions: [:datadog]\nend\n\ndefmodule Sample.App do\n  alias Sample.DataDog\n\n  def send_metrics do\n    Sample.DataDog.start_link()\n\n    tags = [zone: \"us-east-1a\"]\n\n    DataDog.gauge(\"request.queue_depth\", 12, tags: tags)\n\n    DataDog.distribution(\"connections\", 123, tags: tags)\n    DataDog.histogram(\"request.file_size\", 1034, tags: tags)\n\n    DataDog.timing(\"request.duration\", 34, tags: tags)\n\n    DataDog.increment(\"request.count_total\", tags: tags)\n    DataDog.decrement(\"request.count_total\", tags: tags)\n    DataDog.count(\"request.count_total\", 2, tags: tags)\n  end\nend\n```","ref":"DataDaemon.html#module-quick-setup"},{"type":"macro","title":"DataDaemon.__using__/1","doc":"DataDog StatsD reporter.","ref":"DataDaemon.html#__using__/1"},{"type":"macro","title":"Quick Setup - DataDaemon.__using__/1","doc":"```elixir\n# In your config/config.exs file\nconfig :my_app, Sample.DataDog,\n  url: \"statsd+udp://localhost:8125\"\n\n# In your application code\ndefmodule Sample.DataDog do\n  @moduledoc ~S\"My DataDog reporter.\"\n  use DataDaemon,\n    otp_app: :my_app,\n    extensions: [:datadog]\nend\n\ndefmodule Sample.App do\n  alias Sample.DataDog\n\n  def send_metrics do\n    Sample.DataDog.start_link()\n\n    tags = [zone: \"us-east-1a\"]\n\n    DataDog.gauge(\"request.queue_depth\", 12, tags: tags)\n\n    DataDog.distribution(\"connections\", 123, tags: tags)\n    DataDog.histogram(\"request.file_size\", 1034, tags: tags)\n\n    DataDog.timing(\"request.duration\", 34, tags: tags)\n\n    DataDog.increment(\"request.count_total\", tags: tags)\n    DataDog.decrement(\"request.count_total\", tags: tags)\n    DataDog.count(\"request.count_total\", 2, tags: tags)\n  end\nend\n```","ref":"DataDaemon.html#__using__/1-quick-setup"},{"type":"type","title":"DataDaemon.key/0","doc":"Metric key.","ref":"DataDaemon.html#t:key/0"},{"type":"type","title":"DataDaemon.tag/0","doc":"Metric tag value.","ref":"DataDaemon.html#t:tag/0"},{"type":"type","title":"DataDaemon.tags/0","doc":"Metric tags.","ref":"DataDaemon.html#t:tags/0"},{"type":"type","title":"DataDaemon.type/0","doc":"Supported metric types.","ref":"DataDaemon.html#t:type/0"},{"type":"type","title":"DataDaemon.value/0","doc":"Possible metric values.","ref":"DataDaemon.html#t:value/0"},{"type":"module","title":"DataDaemon.Decorators","doc":"Decorators.","ref":"DataDaemon.Decorators.html"},{"type":"function","title":"DataDaemon.Decorators.count/2","doc":"Count function executions.","ref":"DataDaemon.Decorators.html#count/2"},{"type":"function","title":"DataDaemon.Decorators.duration/2","doc":"Alias for timing.\n\nSee `timing/2`.","ref":"DataDaemon.Decorators.html#duration/2"},{"type":"function","title":"DataDaemon.Decorators.timing/2","doc":"Measure function time.","ref":"DataDaemon.Decorators.html#timing/2"},{"type":"extras","title":"Data Daemon","doc":"# Data Daemon\n\n[![Hex.pm](https://img.shields.io/hexpm/v/data_daemon.svg \"Hex\")](https://hex.pm/packages/data_daemon)\n[![Build Status](https://travis-ci.org/IanLuites/data_daemon.svg?branch=master)](https://travis-ci.org/IanLuites/data_daemon)\n[![Coverage Status](https://coveralls.io/repos/github/IanLuites/data_daemon/badge.svg?branch=master)](https://coveralls.io/github/IanLuites/data_daemon?branch=master)\n[![Hex.pm](https://img.shields.io/hexpm/l/data_daemon.svg \"License\")](LICENSE)\n\nAn Elixir StatsD client made for DataDog.","ref":"readme.html"},{"type":"extras","title":"Quick Setup - Data Daemon","doc":"```elixir\n# In your config/config.exs file\nconfig :my_app, Sample.DataDog,\n  url: \"statsd+udp://localhost:8125\"\n\n# In your application code\ndefmodule Sample.DataDog do\n  @moduledoc ~S\"My DataDog reporter.\"\n  use DataDaemon,\n    otp_app: :my_app,\n    extensions: [:datadog, :erlang_vm]\nend\n\ndefmodule Sample.App do\n  alias Sample.DataDog\n\n  def send_metrics do\n    Sample.DataDog.start_link()\n\n    tags = [zone: \"us-east-1a\"]\n\n    DataDog.gauge(\"request.queue_depth\", 12, tags: tags)\n\n    DataDog.distribution(\"connections\", 123, tags: tags)\n    DataDog.histogram(\"request.file_size\", 1034, tags: tags)\n\n    DataDog.timing(\"request.duration\", 34, tags: tags)\n\n    DataDog.increment(\"request.count_total\", tags: tags)\n    DataDog.decrement(\"request.count_total\", tags: tags)\n    DataDog.count(\"request.count_total\", 2, tags: tags)\n  end\nend\n```","ref":"readme.html#quick-setup"},{"type":"extras","title":"Installation - Data Daemon","doc":"The package can be installed\nby adding `data_daemon` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:data_daemon, \"~> 0.4\"}\n  ]\nend\n```\n\nThe docs can\nbe found at [https://hexdocs.pm/data_daemon](https://hexdocs.pm/data_daemon).","ref":"readme.html#installation"},{"type":"extras","title":"Extensions - Data Daemon","doc":"#","ref":"readme.html#extensions"},{"type":"extras","title":"DataDog - Data Daemon","doc":"A DataDog extension is available offering the following functionality:\n\n- `distribution/3` metric.\n- `event/3` event sending over UDP.\n- `error_handler` is available as option and\n  can be used to send errors as events.\n\n##","ref":"readme.html#datadog"},{"type":"extras","title":"Events - Data Daemon","doc":"Create an event for the DataDog event stream by passing a `title` and `message`\nto `event/3`.\n\nThe following options are also supported:\n\n| **Option**                     | **Description**                                                                           |\n| ------------------------------ | ----------------------------------------------------------------------------------------- |\n| `:timestamp` (optional)        | Add a timestamp to the event. Default is the current timestamp.                           |\n| `:hostname` (optional)         | Add a hostname to the event. No default.                                                  |\n| `:aggregation_key` (optional)  | Add an aggregation key to group the event with others that have the same key. No default. |\n| `:priority` (optional)         | Set to `:normal` or `:low`. Default `:normal`.                                            |\n| `:source_type_name` (optional) | Add a source type to the event. No default.                                               |\n| `:alert_type` (optional)       | Set to `:error`, `:warning`, `:info` or `:success`. Default `:info`.                      |\n\n##","ref":"readme.html#events"},{"type":"extras","title":"Example - Data Daemon","doc":"```elixir\ndefmodule Sample.DataDog do\n  @moduledoc ~S\"My DataDog reporter.\"\n  use DataDaemon,\n    otp_app: :my_app,\n    extensions: [:datadog],\n    error_handler: true\nend\n\ndefmodule Sample.App do\n  alias Sample.DataDog\n\n  def send_events do\n    tags = [zone: \"us-east-1a\"]\n\n    DataDog.event(\"Event Title\", \"Event body.\\nMore details\", tags: tags)\n  end\nend\n```\n\nAll event options are support, for more details see: []\n\n#","ref":"readme.html#example"},{"type":"extras","title":"Erlang VM - Data Daemon","doc":"An Erlang VM extension is available logging Erlang VM stats/metrics every minute.\n\nThe reporting interval can be configured with the `:rate` (in millisecond) inside the `:erlang_vm` config.\n\nExample: `config :my_app, MyDaemon, erlang_vm: [rate: 1_000]` for updates every second.\n\nThe following metrics are tracked:\n\n- `vm.process.count`, the current process count.\n- `vm.process.limit`, the current process limit.\n- `vm.process.queue`, the current amount of processes queued for running.\n- `vm.port.count`, the current port count.\n- `vm.port.limit`, the current port limit.\n- `vm.atom.count`, the current atom count.\n- `vm.atom.limit`, the current atom limit.\n- `vm.error.queue`, the amount of process messages queued for the error logger.\n- `vm.uptime`, erlang uptime.\n- `vm.refresh`, the amount of time (ms) since last stat check.\n- `vm.reductions`, amount of reductions.\n- `vm.message.queue`, total queued messages over all processes.\n- `vm.modules`, current amount of loaded modules.\n- `vm.memory.total`, total memory use in Kb.\n- `vm.memory.processes`, total process memory chunk use in Kb.\n- `vm.memory.processes_used`, total process memory use in Kb.\n- `vm.memory.system`, total system memory use in Kb.\n- `vm.memory.atom`, total atom memory chunk use in Kb.\n- `vm.memory.atom_used`, total atom memory use in Kb.\n- `vm.memory.binary`, total binary memory use in Kb.\n- `vm.memory.code`, total code memory use in Kb.\n- `vm.memory.ets`, total ets memory use in Kb.\n- `vm.io.in`, total IO input in Kb.\n- `vm.io.out`, total IO output in Kb.\n- `vm.garbage_collection.count`, number of garbage collections.\n- `vm.garbage_collection.words`, number of words garbage.","ref":"readme.html#erlang-vm"},{"type":"extras","title":"Changelog - Data Daemon","doc":"#","ref":"readme.html#changelog"},{"type":"extras","title":"0.4.5 (2024-04-25) - Data Daemon","doc":"Fix recompilation when IP does not change.\n\n#","ref":"readme.html#0-4-5-2024-04-25"},{"type":"extras","title":"0.4.3 (2023-11-17) - Data Daemon","doc":"Added test helper clear function. (by @punchcafe)\n\n#","ref":"readme.html#0-4-3-2023-11-17"},{"type":"extras","title":"0.4.3 (2023-10-23) - Data Daemon","doc":"Respect runtime configuration.  \nError with `{:error, :not_started}` when Daemon is not started.\n\n#","ref":"readme.html#0-4-3-2023-10-23"},{"type":"extras","title":"0.4.1 (2022-08-09) - Data Daemon","doc":"Fix resolving url with IP as host.\nReduce dependency on Plug.\nNamespace logging.\n\n#","ref":"readme.html#0-4-1-2022-08-09"},{"type":"extras","title":"0.4.0 (2020-08-11) - Data Daemon","doc":"Improved metrics throughput by sharing named sockets/ports.\n\n#","ref":"readme.html#0-4-0-2020-08-11"},{"type":"extras","title":"0.3.4 (2020-03-15) - Data Daemon","doc":"Elixir 1.10 support. (Purely spec updates.)\n\n#","ref":"readme.html#0-3-4-2020-03-15"},{"type":"extras","title":"0.3.3 (2020-02-06) - Data Daemon","doc":"Bug fixes:\n\n- UDP socket leak on DNS refresh.\n\n#","ref":"readme.html#0-3-3-2020-02-06"},{"type":"extras","title":"0.3.2 (2020-02-01) - Data Daemon","doc":"New:\n\n- Full documentation and specs for using module.\n- Doctest support for target module.\n\nBug fixes:\n\n- DataDog distribution custom metric identifier.\n\n#","ref":"readme.html#0-3-2-2020-02-01"},{"type":"extras","title":"0.3.1 (2020-01-31) - Data Daemon","doc":"Changes:\n\n- Custom metric type passing. (binary)\n- Extended module based config options.\n\nBug fixes:\n\n- DataDog specs. (Dialyzer)\n\n#","ref":"readme.html#0-3-1-2020-01-31"},{"type":"extras","title":"0.3.0 (2020-01-30) - Data Daemon","doc":"Changes:\n\n- New socket logic for Erlang OTP 22 and up.\n\nBug fixes:\n\n- Hound spec. (Dialyzer)\n- DataDaemon spec. (Dialyzer)\n\n#","ref":"readme.html#0-3-0-2020-01-30"},{"type":"extras","title":"0.2.4 (2020-01-29) - Data Daemon","doc":"Bug fixes:\n\n- Make hound resolve and open a new socket on some errors.\n\n#","ref":"readme.html#0-2-4-2020-01-29"},{"type":"extras","title":"0.2.3 (2019-04-30) - Data Daemon","doc":"Bug fixes:\n\n- Make hound update async to prevent pool-resolver deadlock.\n\n#","ref":"readme.html#0-2-3-2019-04-30"},{"type":"extras","title":"0.2.2 (2019-04-29) - Data Daemon","doc":"New features:\n\n- `vm.refresh` erlang vm metric that tracks time (ms) since last stat check.\n\nBug fixes:\n\n- Fixes issue where the `vm.uptime` metric wouldn't actually track uptime, but time since last vm check.\n\n#","ref":"readme.html#0-2-2-2019-04-29"},{"type":"extras","title":"0.2.1 (2019-04-27) - Data Daemon","doc":"New features:\n\n- `:minimum_ttl` option to set a minimum TTL to prevent excessive refreshing. (Default: `1_000`)\n\nOptimizations:\n\n- `:erlang_vm` extension runs as additional child to restart during crashes.\n- Perform actual resolve in async process to prevent deadlock during excessive DNS refresh.\n- DNS resolves in separate process removing use of `:timer` and only sending an update to workers if `IP` changes.\n\nBug fixes:\n\n- Fixes issue where the `:erlang_vm` would link its process not to the DataDaemon, but the calling process.\n\n#","ref":"readme.html#0-2-1-2019-04-27"},{"type":"extras","title":"0.2.0 (2019-04-17) - Data Daemon","doc":"New features:\n\n- `:erlang_vm` extension. Logs Erlang VM stats/metrics every minute. (Can be configured)\n\nOptimizations:\n\n- Make config more dynamic.\n- DNS resolves in separate process removing use of `:timer` and only sending an update to workers if `IP` changes.\n\n#","ref":"readme.html#0-2-0-2019-04-17"},{"type":"extras","title":"0.1.4 (2019-03-25) - Data Daemon","doc":"New features:\n\n- Allow config overwrite by passing keyword settings to the child spec or start link.\n\nOptimizations:\n\n- Keep using old IP in case DNS refresh fails.\n- Added extra logging around DNS failures.\n\n#","ref":"readme.html#0-1-4-2019-03-25"},{"type":"extras","title":"0.1.3 (2018-11-03) - Data Daemon","doc":"New features:\n\n- The `:hound` setting now allows you to set the pool settings.\n\nOptimizations:\n\n- DNS lookup only updates header on change.\n\nFixes:\n\n- Functions with default arguments are now properly overwritten.\n\n#","ref":"readme.html#0-1-3-2018-11-03"},{"type":"extras","title":"0.1.2 (2018-10-09) - Data Daemon","doc":"New features:\n\n- Test mode now supported as configuration.\n- The `:error_handler` setting now allows you to set a minimum level.\n  (Default: `:info`, possible: `:debug`, `:info`, `:warn`, and `:error`)\n- Add `:dsn_refresh` config for refreshing the host name.\n  (Default: `:ttl`, possible: `:ttl` and ` `. (seconds))\n\nOptimizations:\n\n- DNS lookup only updates header on change.\n\nFixes:\n\n- Functions with default arguments are now properly overwritten.\n\n#","ref":"readme.html#0-1-2-2018-10-09"},{"type":"extras","title":"0.1.0 (2018-10-07) - Data Daemon","doc":"New features:\n\n- Extension system to allow for different `StatsD` extensions.\n- Add new tag and value formats:\n  - `iodata` now supported for tags and values.\n  - `{:config, app, key}` now supported for tags.\n- DataDog Events are now supported with `event/3`.\n- DataDog can now be used as error handler by setting `error_handler: true`\n  in module.\n\nOptimizations:\n\n- Plug reported optimized for detached user response and\n  compile time optimizations.","ref":"readme.html#0-1-0-2018-10-07"}],"content_type":"text/markdown"}